#include "../apilib.h"
#define RGB(r,g,b)		16 + r + g * 6 + b * 36

void maldenblot(int win, int xsize, int ysize, int zoom, float a)
{
	float i, j, k, r, x, y = -ysize;
	while (y < ysize) {
		x = 0;
		while (x < xsize) {
			api_point(win, x + 8, y + 29 + ysize, RGB(k, k, k));
			i = k = r = 0;
			do {
				j = r * r - i * i - 2 + x / zoom;
				i = 2 * r * i + y / zoom;
				r = j + a;
				k++;
			} while ((j * j + i * i < 256) && (k < 256));
			x++;
		}
		y++;
	}
}

void main(void)
{
	short *buf;
	int win, zoom = 80, i;
	float a = 0;
	api_initmalloc();
	buf = (short *)api_malloc(300 * 300);
	win = api_openwin(buf, 300, 300, -1, "Maldenblot");
	while (1) {
		maldenblot(win, 284, 132, zoom, a);
		i = api_getkey(1);
		if (i == 0x9ed) {
			a += 0.2;
		} else if (i == 0x9eb) {
			a -= 0.2;
		} else if (i == 0x08) {
			zoom -= 50;
		} else if (i == 0x0a) {
			zoom += 50;
		}
	}
	api_end();
}
