#include "apilib.h"
#include <string.h>

// OWavMidiǂݍރeXgł

typedef struct {
	char mthd[3];
	long hsize;
	short format;
	short ntrack;
	short time;
} MidHead;
typedef struct {
	char mtrk[3];
	char a;
	char length[3];
} MidTrack;

int main(void)
{
	int f, size;
	char *buf, *end;

	api_initmalloc();

	// t@Cǂݍ
	{
		f = api_fopen("a.mid");
		if (!f) {
			api_putstr0("Can not open a.mid\n");
			return 1;
		}
		size = api_fsize(f, 0);
		if (size >= 1000000) {
			api_fclose(f);
			api_putstr0("File too big.\n");
			return 1;
		}
		end = buf = (char *)api_malloc(size*2);
		end += size;
		api_fread(buf, size, f);
		api_fclose(f);
	}


	// wb_mF
	{
		MidHead *mid = (MidHead *)buf;
		if (strcmp(mid->mthd, "MThd")) {
			goto err;
		}
	}


	// gbNf[^
	{
		char s[200];
		MidTrack *trk;
		int i, len;

reparse:
		while (strncmp(buf, "MTrk", 4)) {
			if (end - buf == 0) {
				return 0;
			}
			buf++;
		}
		trk = (MidTrack *)buf;

		//api_putstr0(buf);
		len = trk->length[3] + trk->length[2]*0x10 + trk->length[1]*0x100 + trk->length[0]*0x1000 - 1;
		
		//sprintf(s, "%d %d %d %d \n", trk->length[0], trk->length[1], trk->length[2], trk->length[3]);
		//api_putstr0(s);
		buf += sizeof(MidTrack) + 1;
		
		for (i = 0; i <= len;) {
			sprintf(s, "0x%02x\n", buf[i]);
			//api_putstr0(s);
			switch ((unsigned char)buf[i]) {
				case 0x80:
				case 0x81:
				case 0x82:
				case 0x83:
				case 0x84:
				case 0x85:
				case 0x86:
				case 0x87:
				case 0x88:
				case 0x89:
				case 0x8a:
				case 0x8b:
				case 0x8c:
				case 0x8d:
				case 0x8e:
				case 0x8f:
					api_putstr0("~\n");
					i += 3;
					break;
				case 0x90:
				case 0x91:
				case 0x92:
				case 0x93:
				case 0x94:
				case 0x95:
				case 0x96:
				case 0x97:
				case 0x98:
				case 0x99:
				case 0x9a:
				case 0x9b:
				case 0x9c:
				case 0x9d:
				case 0x9e:
				case 0x9f:
					api_putstr0("Đ\n");
					i += 3;
					break;
				case 0xc0:
				case 0xc1:
				case 0xc2:
				case 0xc3:
				case 0xc4:
				case 0xc5:
				case 0xc6:
				case 0xc7:
				case 0xc8:
				case 0xc9:
				case 0xca:
				case 0xcb:
				case 0xcc:
				case 0xcd:
				case 0xce:
				case 0xcf:
					api_putstr0("FύX\n");
					i += 2;
					break;
				case 0xff:
					switch (buf[i+1]) {
						case 0x2f:
							api_putstr0("MTrkI\n");
							i += 3;
							break;
						case 0x51:
							sprintf(s, "e|: %d\n", 1000000*60/((buf[i+3]+1)*0x10000 + buf[i+4]*0x100 + buf[i+5]));
							api_putstr0(s);
							i += 6;
							break;
						default:
							i++;
					}
					break;
				default:
					i++;
					break;
			}
		}
		goto reparse;
	}


	api_free(buf, size*2);

	return 0;
err:
	api_putstr0("Bad file.\n");
	return 1;
nosup:
	api_putstr0("Not support.\n");
	return 1;
}
